
-- Pure signals used in Memory processes

    -- Addressing 
    signal memory_address                   : dword_register ;

    -- Data
    signal rom_output                       : byte_register ;
    signal ram_output                       : byte_register ;
    signal memory_input                     : byte_register ;
    signal memory_output                    : byte_register ;

    signal debug_memory_out                 : byte_register ;

    -- Controls
    signal ram_write_enable                 : std_logic ;
    signal memory_write_enable              : std_logic ;

-- Registers used in Memory processes
    signal last_output                      : byte_register ;
    signal last_memory_output               : byte_register ;

-- Internal registers
    signal instruction_register             : word_register ;
    signal pc_register                      : dword_register ;
    signal operand_address                  : dword_register ;
    signal operand_value                    : dword_register ;
    signal immediate_data_reg               : dword_register ;


    type mdr_source_type is
                ( OV_0_TO_MDR , OV_1_TO_MDR ,
                OV_2_TO_MDR , OV_3_TO_MDR , MDR_UNCHANGED ) ;

    type mar_source_type is ( PC_TO_MAR , OA_TO_MAR ) ;

    type ir_source_type is ( MDR_TO_IR_1 , MDR_TO_IR_0 , IR_UNCHANGED ) ;

    type operand_value_source_type is
            ( MDR_TO_OV_3 , MDR_TO_OV_2 ,
            MDR_TO_OV_1 , MDR_TO_OV_0 , 
            ALU_TO_OV , OV_UNCHANGED ) ;

    type immediate_data_source_type is
            ( MDR_TO_IDR_3 , MDR_TO_IDR_2 ,
            MDR_TO_IDR_1 , MDR_TO_IDR_0 ,
            MDR_TO_IDR_1_SE , MDR_TO_IDR_0_SE , IDR_UNCHANGED ) ;

    type pc_source_type is ( ALU_TO_PC , PC_UNCHANGED ) ;

    type operand_address_source_type is
            ( ALU_TO_OA , MDR_TO_OA_1_SE ,
            MDR_TO_OA_3 , MDR_TO_OA_2 ,
            MDR_TO_OA_1 , MDR_TO_OA_0 , OA_UNCHANGED ) ;

