

    operation_size_control_process : process ( clock ,
                operation_size_control , instruction_register ) is
    begin
        if ( clock = '1' )
        and ( clock'event )
        then
            case operation_size_control is
            when SET_TO_BYTE =>
                    operation_size <= BYTE ;
            when SET_TO_WORD =>
                    operation_size <= WORD ;
            when SET_TO_DWORD =>
                    operation_size <= DWORD ;
            when SET_TO_IR =>
                    case instruction_register ( 7 downto 6 ) is
                    when "00" =>    -- Byte size.
                            operation_size <= BYTE ;
                    when "01" =>    -- Word size.
                            operation_size <= WORD ;
                    when others =>  -- DWord size.
                            operation_size <= DWORD ;
                    end case ;
            when others =>
                    null ;
            end case ;
        end if ;
    end process operation_size_control_process ;

