
#ifndef UTILS_H
#define UTILS_H

#include <stdio.h>
#include <regex.h>


extern int g_verbose_setting ;

#define VERBOSE_OFF         0
#define VERBOSE_LOW         1
#define VERBOSE_MEDIUM      2
#define VERBOSE_HIGH        3
#define VERBOSE_VERY_HIGH   4

#define MESSAGE     if ( g_verbose_setting >= VERBOSE_LOW ) printf
#define MESSAGE2    if ( g_verbose_setting >= VERBOSE_MEDIUM ) printf
#define MESSAGE3    if ( g_verbose_setting >= VERBOSE_HIGH ) printf
#define MESSAGE4    if ( g_verbose_setting >= VERBOSE_VERY_HIGH ) printf

                    
/* This procedure deletes the newline character and everything
 * after it from the supplied string. If no newline character
 * is present, the string is unchanged. */
void Remove_Trailing_Newlines ( char * str ) ;

/* Extracts a particular regular expression match substring from
 * match_str. An assertion fails if the regex function didn't find any
 * substring to match the specified pattern.. i.e. if the match
 * parameter is not valid.
 * 
 * Note: a deep copy of the substring is made that will need to be freed
 * later. */
char * Get_Regex_Match ( const char * match_str , regmatch_t * match ) ;

/* Compute the minimum number of bits required to represent 
 * the integer parameter. */
int Get_Number_Of_Bits_Needed_For ( int parameter ) ;

void Print_Binary ( FILE * fd , int number , int width ) ;

bool String_Contains_Non_Whitespace ( const char * str ) ;

void Remove_Whitespace_From_Ends ( char * str ) ;

const char * Binary_To_String ( int number , int width ) ;

const char * Copy_String ( const char * original ) ;

#endif

